<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Generator\Business\Field\Date;
use Setforms2\Shared\Registry;

class AvlPadravalfilial extends Base\AvlPadravalfilial
{
    public static function consultaPeriodoVigencia($nrorg, $cdfilial, $dtinicial, $dtfinal, $dtinicial_old, $dtfinal_old){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA <> ? AND DTFINALVIGENCIA <> ?
                 AND ((? BETWEEN DTINICIALVIGENCIA AND DTFINALVIGENCIA) OR (? BETWEEN DTINICIALVIGENCIA AND DTFINALVIGENCIA))',
                array($nrorg, $cdfilial, $dtinicial_old, $dtfinal_old, $dtinicial, $dtfinal)
            );
            return $obj;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function atualizaPadrAvalPorData($nrorg, $cdfilial, $dtinicial, $dtfinal, $dtinicial_old, $dtfinal_old){
        $obj = self::retornaPadrAvalPorData($nrorg, $cdfilial, $dtinicial_old, $dtfinal_old);
        if (is_object($obj)){
            /** @var $registro \Avaliacao\Entities\Base\AvlPadravalfilial */
            foreach($obj as $registro){
                $registro->setDtinicialvigencia($dtinicial);
                $registro->setDtfinalvigencia($dtfinal);
                $registro->setDtultatu(now());
                $registro->setCdoperultatu(\Geral\Util\Ambiente::getCdOperador());
                $registro->persist();
            }
        } else {
            return false;
        }
        return true;
    }

    public static function retornaPadrAvalPorData($nrorg, $cdfilial, $dtinicial, $dtfinal){
        if ($dtfinal == '1/1/1') {
            $where = '';
        } else {
            $where = " AND DTFINALVIGENCIA = '$dtfinal'";
        }

        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ?'.$where,
                array($nrorg, $cdfilial, $dtinicial)
            );

            return $obj;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function retornaMaiorDataVigenciaQuestionario($nrorg, $filial, $nrpadravaliacao){
        $query = "SELECT MAX(DTINICIALVIGENCIA) MAIOR
                    FROM AVL_PADRAVALFILIAL
                   WHERE NRORG = {$nrorg}
                     AND CDFILIAL = {$filial}
                     AND (DTINICIALVIGENCIA < SYSDATE OR DTINICIALVIGENCIA = SYSDATE)
                     AND (DTFINALVIGENCIA > SYSDATE OR DTFINALVIGENCIA = SYSDATE OR DTFINALVIGENCIA IS NULL)
                     AND NRPADRAVALIACAO = {$nrpadravaliacao}";

        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($query);
        return $result;
    }

    public static function retornaQuestionarioFilial($nrorg, $filial, $data_vigencia_inicial, $item_avaliacao) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRITEMAVALIACAO = ?',
            array(
                $nrorg,
                $filial,
                $data_vigencia_inicial,
                $item_avaliacao,
            )
        );
        if (!is_array($objs)) {
            $objs = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRITEMAVALIACAO IS NULL',
                array(
                    $nrorg,
                    $filial,
                    $data_vigencia_inicial,
                )
            );
        }

        return $objs;

    }

    public function retornaQuestionariosFilial($nrorg, $cdfilial) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ?',
            array(
                $nrorg,
                $cdfilial,
            )
        );
        return $objs;
    }

    public function retornaQuestionario($nrorg, $cdfilial, $nrquestionario, $dt_vigencia_inicial, $nritemavaliacao) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND  CDFILIAL = ? AND NRPADRAVALIACAO = ? AND DTINICIALVIGENCIA = ? AND NRITEMAVALIACAO = ?',
            array(
                $nrorg,
                $cdfilial,
                $nrquestionario,
                $dt_vigencia_inicial,
                $nritemavaliacao,
            )
        );
        if (!is_object($obj)) {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND  CDFILIAL = ? AND NRPADRAVALIACAO = ? AND DTINICIALVIGENCIA = ? AND NRITEMAVALIACAO IS NULL',
                array(
                    $nrorg,
                    $cdfilial,
                    $nrquestionario,
                    $dt_vigencia_inicial,
                )
            );
        }
        return $obj;
    }

    public function incluiQuestionario($nrorg, $cdfilial, $nrquestionario, $nritemavalicao, $dt_inicio_vigencia, $dt_fim_vigencia) {
        try{
            $obj = new self();
            $obj->setNrorg($nrorg);
            $obj->setCdfilial($cdfilial);
            $obj->setNrpadravalfilial(NovoCodigo::geraCodigo($nrorg, 'AVL_PADRAVALFILIAL',1,10,true));
            $obj->setNrpadravaliacao($nrquestionario);
            $obj->setNritemavaliacao($nritemavalicao);
            $obj->setDtinicialvigencia($dt_inicio_vigencia);
            $obj->setDtfinalvigencia($dt_fim_vigencia);
            $obj->setNrorginclusao($nrorg);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setIdativo('S');
            $obj->setNrorgultatu($nrorg);
            $obj->persist();

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {
            tk_warning('Erro '.$e->getMessage());
        }

    }
}