<?php

require_once 'base/GpeescalatrabmEntityBase.php';


/**
 * GpeescalatrabmEntity.
 *
 * @package Entity
 * @author  alessandrobartels
 *
 */
class GpeescalatrabmEntity extends GpeEscalatrabmEntityBase
{


    /**
     * Inicializa lista de Escalas de Trabalho.
     *
     * @param integer $nrOrg Numero da Organizacao de trabalho.
     *
     * @return void
     */
    private function _inicializaLista($nrOrg){
        $tmp = Gpeescalatrabm::retornaEscalas($nrOrg);
        foreach ($tmp as $tmp_escala) {
            $this->addItem($tmp_escala, $tmp_escala->getNrescalatrabm());
        }
    }


    /**
     * Retorna instancia da escala parametrizada.
     *
     * @param integer $nr_escala Numero da Escala de trabalho.
     * @param integer $nrOrg     Numero da Organizacao de trabalho.
     *
     * @return GpeescalatrabmEntity
     */
    public function retornaEscala($nr_escala, $nrOrg){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista($nrOrg);
            $itens = $this->getItems();
        }

        return $itens[$nr_escala];
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrescalatrabm Nr Escala Trabalho.
     * @param integer $nrorgTrab     Nr Org.
     *
     * @return boolean
     *
     * @author luistavares 11/08/2011
     */
    public function novoMestre($nrescalatrabm, $nrorgTrab){
        try{
            $now = new TkDateTime();
            $now = $now->toString(TkDateTime::FORMAT_DATE);

            $this->setNrescalatrabm($nrescalatrabm);
            $this->setDtinivigencia($now);
            $this->setNrorg($nrorgTrab);
            $this->setDtinclusao($now);

            $this->persist();

            return true;
        }
        catch (Exception $e){
            return false;
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer $nrescalatrabm Nr Escala Trabalho.
     * @param integer $nrorgTrab     Nr Org.
     *
     * @return boolean
     *
     * @author luistavares 11/08/2011
     */
    public function destroiMestre($nrescalatrabm, $nrorgTrab){
        try{
            $escalatrab = Gpeescalatrabm::retornaEscalaTrab($nrescalatrabm, $nrorgTrab);
            if (is_object($escalatrab) === true) {
                /* Adiciona um item  lista, aps isso, o item  removido da lista
                 * e enviado para lista de itens removidos, lista essa que ir apagar
                 * todos seus itens quando executar o persist(). */
                $this->addItem($escalatrab, $nrescalatrabm);
                $this->removeItem($escalatrab);
                $this->persist();

                return true;
            } else {
                return false;
            }
        }
        catch (Exception $e){
            tk_warning($e->getMessage());
            return false;
        }

    }


}

